from django.db import models
from account.views import Account
import random

def generate_supplier_code():
    random_number = str(random.randint(0, 999999)).zfill(6)
    return f'SID{random_number}'

class Supplier(models.Model):
    supplier_id = models.AutoField(primary_key=True)
    sid = models.CharField(max_length=200, default=generate_supplier_code())
    added_by = models.ForeignKey(Account, on_delete=models.SET_NULL, null=True, blank=True)
    
    # Supplier Information
    supplier_name = models.CharField(max_length=100)
    contact_name = models.CharField(max_length=100, blank=True, null=True)
    email = models.EmailField(max_length=100, blank=True, null=True)
    phone = models.CharField(max_length=20, blank=True, null=True)
    
    # Address Information
    address = models.CharField(max_length=50, blank=True, null=True)
    city = models.CharField(max_length=50, blank=True, null=True)
    state = models.CharField(max_length=50, blank=True, null=True)
    postal_code = models.CharField(max_length=10, blank=True, null=True)
    country = models.CharField(max_length=50, blank=True, null=True)
    
    # Tax Information
    kra_pin = models.CharField(max_length=20, blank=True, null=True)

    def __str__(self):
        return self.supplier_name
    
    class Meta:
        db_table = "tbl_supplier"
